# coding: utf-8

"""
    NCBI Datasets API

    NCBI service to query and download biological sequence data across all domains of life from NCBI databases.  # noqa: E501

    The version of the OpenAPI document: v1alpha
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ncbi.datasets.configuration import Configuration


class V1alpha1AssemblyDatasetAvailability(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'invalid_assemblies': 'list[str]',
        'reason': 'str',
        'valid_assemblies': 'list[str]'
    }

    attribute_map = {
        'invalid_assemblies': 'invalid_assemblies',
        'reason': 'reason',
        'valid_assemblies': 'valid_assemblies'
    }

    def __init__(self, invalid_assemblies=None, reason=None, valid_assemblies=None, local_vars_configuration=None):  # noqa: E501
        """V1alpha1AssemblyDatasetAvailability - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._invalid_assemblies = None
        self._reason = None
        self._valid_assemblies = None
        self.discriminator = None

        if invalid_assemblies is not None:
            self.invalid_assemblies = invalid_assemblies
        if reason is not None:
            self.reason = reason
        if valid_assemblies is not None:
            self.valid_assemblies = valid_assemblies

    @property
    def invalid_assemblies(self):
        """Gets the invalid_assemblies of this V1alpha1AssemblyDatasetAvailability.  # noqa: E501


        :return: The invalid_assemblies of this V1alpha1AssemblyDatasetAvailability.  # noqa: E501
        :rtype: list[str]
        """
        return self._invalid_assemblies

    @invalid_assemblies.setter
    def invalid_assemblies(self, invalid_assemblies):
        """Sets the invalid_assemblies of this V1alpha1AssemblyDatasetAvailability.


        :param invalid_assemblies: The invalid_assemblies of this V1alpha1AssemblyDatasetAvailability.  # noqa: E501
        :type: list[str]
        """

        self._invalid_assemblies = invalid_assemblies

    @property
    def reason(self):
        """Gets the reason of this V1alpha1AssemblyDatasetAvailability.  # noqa: E501


        :return: The reason of this V1alpha1AssemblyDatasetAvailability.  # noqa: E501
        :rtype: str
        """
        return self._reason

    @reason.setter
    def reason(self, reason):
        """Sets the reason of this V1alpha1AssemblyDatasetAvailability.


        :param reason: The reason of this V1alpha1AssemblyDatasetAvailability.  # noqa: E501
        :type: str
        """

        self._reason = reason

    @property
    def valid_assemblies(self):
        """Gets the valid_assemblies of this V1alpha1AssemblyDatasetAvailability.  # noqa: E501


        :return: The valid_assemblies of this V1alpha1AssemblyDatasetAvailability.  # noqa: E501
        :rtype: list[str]
        """
        return self._valid_assemblies

    @valid_assemblies.setter
    def valid_assemblies(self, valid_assemblies):
        """Sets the valid_assemblies of this V1alpha1AssemblyDatasetAvailability.


        :param valid_assemblies: The valid_assemblies of this V1alpha1AssemblyDatasetAvailability.  # noqa: E501
        :type: list[str]
        """

        self._valid_assemblies = valid_assemblies

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, V1alpha1AssemblyDatasetAvailability):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, V1alpha1AssemblyDatasetAvailability):
            return True

        return self.to_dict() != other.to_dict()
